/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             List
*  SCOPE :              List common services
*  FILE :               list.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif
#ifndef __listln_HXX
#define __listln_HXX

/* IMPORTS *******************************************************************/

#ifndef __col_HXX
#include "col.hxx"
#endif

/*****************************************************************************/
class ListLeaf ;
class ListNode ;
yoo_declare2(ListLeaf, ColLeaf, Collection) ;
yoo_declare2(ListNode, ColNode, Collection) ;

// 316
const int ListNbInNode = (MAX_OBJ_SIZE-sizeof(ColNode))/sizeof(ColNodeElem) ;

class ListLeaf : public ColLeaf {

protected :
  // Return a clone of the leaf
  Ref<Collection> clone() ;

    // Use to build a new root 
  Ref<ColNode> newNode() ;
  
public :
  ListLeaf() {} ;
  ListLeaf(int card) : ColLeaf(card) {} ;
  ~ListLeaf() {} ;

  // Tips to refresh virtual table address
  static void yoo_refresh(void* addr) ;
} ;


class ListNode : public ColNode {

protected :
  // Use char array to avoid empty construction during refresh phase
  char _tab[sizeof(ColNodeElem)*ListNbInNode] ;

  // Return a clone of the node
  Ref<Collection> clone() ;

  // Return the address of nth element of the node
  ColElem* tab(int pos) ;

  // Size of an element of a collection
  int sizeElem() ;

  // Maximum Number of element in a collection leaf or node
  int maxElem() ;

public :
  ListNode() {} ;
  ListNode(int c) : ColNode(c) {} ;
  ~ListNode() {} ;

  // Tips to refresh virtual table address
  static void yoo_refresh(void* addr) ;
} ;

#endif
